// -*-C++-*-
/*!
 * @file  ObjectPoseEstimation2ServiceSVC_impl.cpp
 * @brief Service implementation code of ObjectPoseEstimation2Service.idl
 *
 */

#include "ObjectPoseEstimation2ServiceSVC_impl.h"

#include "SwissRangerRTCData.h"

#include "mesaRangeData.h"

#include "opencv/cvmath/cvmath.h"

#include <fstream>

//BNew, CNew`Ă
#include "ip.h"

//Mx臒l
extern float ConfidenceThresh;

/*
 * Example implementational code for IDL interface ObjectPoseEstimationRTC::idl::OPEService
 */
OPEServiceSVC_impl::OPEServiceSVC_impl(Point3DList** pDPPoint3DList, SensorRTC::SRSensor::idl::TimedSwissRanger** pDPSwissRanger,/* RTC::TimedPose3D** pDPObjectPose,*/ CRITICAL_SECTION* g_CritSec)
{
	pPoint3DList = pDPPoint3DList;
	pSwissRanger = pDPSwissRanger;

	calibrationFlag = true;
  // Please add extra constructor code here.
}


OPEServiceSVC_impl::~OPEServiceSVC_impl()
{
  // Please add extra destructor code here.
}


/*
 * Methods corresponding to IDL attributes and operations
 */
CORBA::Boolean OPEServiceSVC_impl::calibrationSensor()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Boolean OPEServiceSVC_impl::calibrationSensor()>"
#endif
	int calibrationSuccessFlag;

	IplImage *amplitudeimg;

	CvSize r_size = cvSize(WIDTH_VALUE, HEIGHT_VALUE);
	amplitudeimg = cvCreateImage(r_size, IPL_DEPTH_8U, 1);
	
	printf("drawamplitudeimg");
	//wi̍WlE摜擾
	DrawAmplitudeImg( &amplitudeimg );
	printf("saveimage");	
	//摜ۑ
	cvSaveImage("background.png", amplitudeimg);
	printf("rangedata");	
	for(int i = 0; i < (WIDTH_VALUE * HEIGHT_VALUE); i++)
	{
		RangeDatalist[i].x = (*pPoint3DList)->data[i].data.x;
		RangeDatalist[i].y = (*pPoint3DList)->data[i].data.y;
		RangeDatalist[i].z = (*pPoint3DList)->data[i].data.z;
	}
	printf("calibdata");
	//ZTLu[V
	calibrationSuccessFlag = CalibData();

	if(calibrationSuccessFlag == 1)
	{
		calibrationFlag = false;
		return 0;
	}

	calibrationFlag = true;

	cvReleaseImage(&amplitudeimg);
  return 1;
}

CORBA::Boolean OPEServiceSVC_impl::getBackground()
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <CORBA::Boolean OPEServiceSVC_impl::getBackground()>"
#endif
	CvSize r_size = cvSize(WIDTH_VALUE, HEIGHT_VALUE);

	IplImage *amplitudeimg;
	IplImage *confidenceimg;

	amplitudeimg = cvCreateImage(r_size, IPL_DEPTH_8U, 1);
	confidenceimg = cvCreateImage(r_size, IPL_DEPTH_8U, 1);
	
	printf("drawamplitudeimg");
	//wi̍WlE摜擾
	DrawAmplitudeImg( &amplitudeimg );
	DrawConfidenceImg( &confidenceimg );

	printf("saveimage");	
	//摜ۑ
	cvSaveImage("background.png", amplitudeimg);
	cvSaveImage("confidence.png", confidenceimg);
	printf("rangedata");	

	int ind = 0;
	int zero_count = 0;

	do{
		for(int h = 0; h < HEIGHT_VALUE; h++)
		{
			for(int w = 0; w < WIDTH_VALUE; w++)
			{
				if(h == 0 && w == 0)
					zero_count = 0;

				ind = h * WIDTH_VALUE + w;

				if((*pSwissRanger)->data.confidence[h][w] > ConfidenceThresh)
				{

					RangeDatalist[ind].x = (*pPoint3DList)->data[ind].data.x;
					RangeDatalist[ind].y = (*pPoint3DList)->data[ind].data.y;
					RangeDatalist[ind].z = (*pPoint3DList)->data[ind].data.z;

					if(RangeDatalist[ind].z < 0.02)
						zero_count++;

				}
				else
				{
					RangeDatalist[ind].x = 5.0;
					RangeDatalist[ind].y = 5.0;
					RangeDatalist[ind].z = 5.0;
				}
			}
		}	
	}while(zero_count > 5000);

	printf("getbackgrounddata");
	GetBackgroundData(0);

	cvReleaseImage(&amplitudeimg);
	cvReleaseImage(&confidenceimg);

//Lu[V̌C͂Đ肷邽߁C
//	calibrationFlag = false;

  return 1;
}

/*
 * ʒupT[rXi݂͎gpĂȂj
 */
ObjectPoseEstimationRTC::idl::Pose3DList *OPEServiceSVC_impl::getObjectPose(CORBA::Long id)
{
  // Please insert your code here and remove the following warning pragma
#ifndef WIN32
  #warning "Code missing in function <ObjectPoseEstimationRTC::idl::Pose3DList OPEServiceSVC_impl::getObjectPose(CORBA::Long id)>"
#endif

	//߂l̏
	ReturnPose3DList.poseidlist.length(0);

	return &ReturnPose3DList;

}

void OPEServiceSVC_impl::DrawAmplitudeImg( IplImage **amplitudeimg ){

	int ind, w, h;
	unsigned char uval;
	double maxz = 0.0;

	for(h = 0; h < HEIGHT_VALUE; h++ )
	{
		for(w = 0; w < WIDTH_VALUE; w++)
			maxz = max(maxz, (double)(*pSwissRanger)->data.amplitude[h][w]);
	}

	for(h = 0; h < HEIGHT_VALUE; h++)
	{
		for(w = 0; w < WIDTH_VALUE; w++)
		{
			uval = (unsigned char)((double)(*pSwissRanger)->data.amplitude[h][w] * 255.0 / (maxz + 0.1));
			
			(*amplitudeimg)->imageData[(*amplitudeimg)->widthStep * h + w] = uval;

		}
	}
		
}

void OPEServiceSVC_impl::DrawDistanceImg( IplImage **distanceimg){

	int ind, w, h;
	unsigned char uval;
	double maxz = 0.0;

	for(h = 0; h < HEIGHT_VALUE; h++ )
	{
		for(w = 0; w < WIDTH_VALUE; w++)
			maxz = max(maxz, (double)(*pPoint3DList)->data[(WIDTH_VALUE * h) + w].data.z);
	}

	for(h = 0; h < HEIGHT_VALUE; h++)
	{
		for(w = 0; w < WIDTH_VALUE; w++)
		{
			uval = (unsigned char)((double)(*pPoint3DList)->data[(WIDTH_VALUE * h) + w].data.z * 255.0 / (maxz + 0.1));

			(*distanceimg)->imageData[(*distanceimg)->widthStep * h + w] = uval;
		}
	}
		
}

void OPEServiceSVC_impl::DrawConfidenceImg( IplImage **confidenceimg){

	int ind, w, h;
	unsigned char uval;
	double maxz = 0.0;

	for(h = 0; h < HEIGHT_VALUE; h++ )
	{
		for(w = 0; w < WIDTH_VALUE; w++)
			maxz = max(maxz, (double)(*pSwissRanger)->data.amplitude[h][w]);
	}

	for(h = 0; h < HEIGHT_VALUE; h++)
	{
		for(w = 0; w < WIDTH_VALUE; w++)
		{
			uval = (unsigned char)((double)(*pSwissRanger)->data.amplitude[h][w] * 255.0 / (maxz + 0.1));
			if((*pSwissRanger)->data.confidence[h][w] > ConfidenceThresh)
			{

				(*confidenceimg)->imageData[(*confidenceimg)->widthStep * h + w] = uval;
			}
			else
				(*confidenceimg)->imageData[(*confidenceimg)->widthStep * h + w] = 0;

		}
	}
		
}
// End of example implementational code



