#define CVMATH_LINK_LIBS_220
#include "cvmath.h"
#include <iostream>

using namespace std;
using namespace opencv::cvmath;


int main(void){
	Vector<CV_32F> v32f(3);	v32f(0) = 0;	v32f(1) = 1;	v32f(2) = 2;	v32f.print();
	Vector<CV_64F> v64f(3);	v64f(0) = 0;	v64f(1) = 1;	v64f(2) = 2;	v64f.print();
	
	Matrix<CV_32F> m32f(2, 3);	for(int i = 0; i < 2; ++ i) for(int j = 0; j < 3; ++ j)	m32f(i, j) = float(i*3+j);	m32f.print();
	Matrix<CV_64F> m64f(5, 3);	for(int i = 0; i < 5; ++ i) for(int j = 0; j < 3; ++ j)	m64f(i, j) = double(i*3+j);	m64f.print();
	
	Matrix<CV_32F> a(2, 2), b(2, 2), c(2, 2);	
	a.setI();
	b.setAll(10);
	c.MxM(a, b);

	c.print();

#if 0
	Matrix<CV_64F> Rx(3, 3);

	double rx[] = {
		1, 0, 0,
		0, cos(deg2rad(25)), sin(deg2rad(25)),
		0,-sin(deg2rad(25)), cos(deg2rad(25))
	};
	Rx.set(rx);

	Matrix<CV_64F> Ry(3, 3);
	double ry[] = {
		cos(deg2rad(90)), 0, sin(deg2rad(90)),
		0, 1, 0,
		-sin(deg2rad(90)), 0, cos(deg2rad(90))
	};
	Ry.set(ry);

	Matrix<CV_64F> R(3, 3);
	R.MxM(Rx, Ry);

	Matrix<CV_64F> Qx(3, 3);
	double qx[] = {
		1, 0, 0,
		0, cos(deg2rad(-25)), sin(deg2rad(-25)),
		0,-sin(deg2rad(-25)), cos(deg2rad(-25))
	};
	Qx.set(qx);

	Matrix<CV_64F> Qy(3, 3);
	double qy[] = {
		cos(deg2rad(-90)), 0, sin(deg2rad(-90)),
		0, 1, 0,
		-sin(deg2rad(-90)), 0, cos(deg2rad(-90))
	};
	Qy.set(qy);

	Matrix<CV_64F> Q(3, 3);
	Q.MxM(Qy, Qx);
	
	Matrix<CV_64F> S(3, 3);
	S.MxM(Q, R);
	std::cout << "S" << std::endl; S.print();

	Vector<CV_64F> p(3), q(3);
	p.set(0, 1);	p.set(1, 0);	p.set(2, 1);
	q.MxV(R, p);
	q.print();

	{		
		Quaternion<CV_64F> q, qi, qqi;
		q.set(0, 1);	q.set(1, 2);	q.set(2, 3);	q.set(3, 4);
		q.print();
		q.invert(qi);
		qqi.QxQ(q, qi);
		qqi.print();
	}


	Matrix<CV_64F> A(3, 3),	EVs(3, 3);
	Vector<CV_64F> evs(3);

	A.set(0, 0, 1.0);	A.set(0, 1, 0.0);	A.set(0, 2, 0.0);
	A.set(1, 0, 0.0);	A.set(1, 1, 1.0);	A.set(1, 2, 0.0);
	A.set(2, 0, 0.0);	A.set(2, 1, 0.0);	A.set(2, 2, 1.0);

	calculateEigenValueAndEigenVector33(A, evs, EVs);

	std::cout << "A" << std::endl;
	A.print();

	std::cout << "evs" << std::endl;
	evs.print();

	std::cout << "EVs" << std::endl;
	EVs.print();
#endif

	getchar();

	return 0;
}
