#include "labeler.h"
#include <iostream>
//#include "../../asm/intrinsics/sse.h"

using std::cout;
using std::endl;
//using namespace intrinsics::sse;

#ifdef IMG_DEBUG
int Image<unsigned char>::id_count = 0;
int Image<int>::id_count = 0;
#endif

/**
	RXgN^
*/
Labeler::Labeler()
{
	cout << ">> Labeler::Labeler() <<" << endl;
}


/**
	fXgN^
*/
Labeler::~Labeler()
{
	cout << ">> Labeler::~Labeler() <<" << endl;
	labeled.release();
}


/**
	
*/
void Labeler::initialize( int w, int h )
{
	cout << ">> Labeler::initialize() ";
	this->w = w, this->h = h;
#	if 1
	labeled.create(w, h, 1);
#	else
	labeled.create(((w+15)>>4)<<4, h, 1);
		// ͉摜1Byte(16ByteXgCh)C
		// labeled4byte(16ByteXgCh)
		// ̂ƂCw = 5 ̉摜ɑ΂Ă
		//	͉摜 stride = 16pix = (1Byte x 16) x 1
		//	labeled stride =  8pix = (4Byte x 4)  x 2
		// copyImage()̑R[hgɂ́C
		//	u += 16 ̂Ƃ ẘmۂł̓G[N
		//	߂ ((w+15)>>4)<<4 mۂ
#endif
	labeled.clear();
	cout << "<<" << endl;
}


/**
	xO
*/
int Labeler::process( const opencv::cvutil::Image<IPL_DEPTH_8U> &src_gray )
{
	/*  */
	ps.clear();				// WX^bNNA
	liv.clear();			// xNA
	liv.push_back( LabelInfo() );	// 0Ԗxǉ
		
	copyImage( src_gray );
	processFirstPath();
	processSecondPath();

	return 0;
}


/**
	xOʂ̕\
*/
void Labeler::print() const
{
	int i = 1;
	for(LabelInfoVec::const_iterator cit = liv.begin()+1; cit != liv.end(); ++ cit, ++ i){
		printf("id=%4d, com=(%lf, %lf), pix_n=%d\n",
			i, cit->center_of_mass.x, cit->center_of_mass.y, cit->pix_n);
	}
}


/**
	摜̃Rs[
*/
void Labeler::copyImage( const opencv::cvutil::Image<IPL_DEPTH_8U> &src )
{
#if 1
	for(int v = 0; v < h; ++ v){
		const unsigned char *sp = &src(0,v);
		int *dp = &labeled(0,v);
		for(int u = 0; u < w; ++ u){
			*(dp ++) = *(sp ++) ? -1 : 0;
			//printf("%d, %d\n", u, v);
			//labeled(u, v) = src_gray(u, v) ? -1 : 0;
		}
	}
#else
	// G[ obt@I[o[n
	const uchar16 ZEROs = pzerodq(), FFx4 = palld(0xFF);
	short8 src07, src8F;
	int4 src03, src47, src8B, srcCF;
	for( int v = 0; v < h; ++ v ) {
		const uchar16 *srcp = (uchar16 *) &src(0,v);
		int4 *dstp = ((int4 *) &labeled(0,v)) -1;

		for( int u = 0; u < w; u += 16 ) {
			// ͂̃rbgg
			src07 = punpcklbw( *srcp, ZEROs );
			src8F = punpckhbw( *srcp, ZEROs );

			src03 = punpcklwd(src07, ZEROs);
			src47 = punpckhwd(src07, ZEROs);
			src8B = punpcklwd(src8F, ZEROs);
			srcCF = punpckhwd(src8F, ZEROs);
			
			//printf("%02x %02x %02x %02x ", xmm<int>(dstp, 0), xmm<int>(dstp, 1), xmm<int>(dstp, 2), xmm<int>(dstp, 3));
			//printf("%02x %02x %02x %02x ", xmm<int>(dstp, 0), xmm<int>(dstp, 1), xmm<int>(dstp, 2), xmm<int>(dstp, 3));
			//printf("%02x %02x %02x %02x ", xmm<int>(dstp, 0), xmm<int>(dstp, 1), xmm<int>(dstp, 2), xmm<int>(dstp, 3));
			//printf("%02x %02x %02x %02x\n", xmm<int>(dstp, 0), xmm<int>(dstp, 1), xmm<int>(dstp, 2), xmm<int>(dstp, 3));
			
			*(++dstp) = pcmpeqd(src03, FFx4);
			*(++dstp) = pcmpeqd(src47, FFx4);
			*(++dstp) = pcmpeqd(src8B, FFx4);
			*(++dstp) = pcmpeqd(srcCF, FFx4);
			++ srcp;
		}
	}
#endif
}


/**
	1pXڂ̎s
*/
void Labeler::processFirstPath()
{
	int u, v, x, y;
	int lbl;

	for( v = 0; v < h; ++ v ) {
		for( u = 0; u < w; ++ u ) {
			// xOΏۂ̉fȂ珈
			if( labeled(u,v) == -1 ) {
				labeled(u,v) = lbl = liv.size();
				liv.push_back( LabelInfo() );

				// ݂̍W̕ۑ
				ps.push_back( point(u,v) );
					
				while( ps.size() ) {
					// 4ߖTÃ`FbN
					x = (int) ps.back().x, y = (int) ps.back().y;
					ps.pop_back();

					if( y > 0		&& labeled.N(x,y) == -1)  labeled.N(x,y) = lbl, ps.push_back(point(x,y-1));	// k
					if( y < h-1	&& labeled.S(x,y) == -1)  labeled.S(x,y) = lbl, ps.push_back(point(x,y+1));	// 
					if( x > 0		&& labeled.W(x,y) == -1)  labeled.W(x,y) = lbl, ps.push_back(point(x-1,y));	// 
					if( x < w-1	&& labeled.E(x,y) == -1)  labeled.E(x,y) = lbl, ps.push_back(point(x+1,y));	// 
				}
			}
		}
	}


}
	

/**
	2pXڂ̎s
*/
void Labeler::processSecondPath()
{
	int lbl;
	for( int v = 0; v < h; ++ v ) {
		int *dp = &labeled(0,v);
		for( int u = 0; u < w; ++ u, ++ dp ) {
			if( !*dp ) continue;
			
			/* dSvZ̏ƖʐωZ */
			lbl = *dp; // xID
			liv[lbl].center_of_mass.x += u;
			liv[lbl].center_of_mass.y += v;
			liv[lbl].pix_n ++;
		}
	}

	/* dSvZ̎c */
	for( LabelInfoVec::iterator it = liv.begin()+1; it != liv.end(); ++ it ) {
		it->center_of_mass.x /= it->pix_n;
		it->center_of_mass.y /= it->pix_n;
	}
}



