#define CVUTIL_LINK_LIBS_220
#include "cvutil.h"
//#include "../../Image/Image/Image.h"
#include <cstdio>
#include <iostream>
#include <sstream>


#pragma comment(lib, "opencv_calib3d220.lib")



int main()
{
#if 1
	opencv::cvutil::Window win("unditorted");
	win.open();

	static const char *PATH = "C:/Users/AISL/Documents/sugiyama/ac022mini-fisheye/";
	static const char *SUFFIX = "bmp";

	CvMat *intrinsic, *distortion;
	CvFileStorage *fs;
	CvFileNode *param;

	fs = cvOpenFileStorage("C:/Users/AISL/Documents/sugiyama/ac022mini-fisheye/ac022mini-fisheye.xml", 0, CV_STORAGE_READ);
	param = cvGetFileNodeByName(fs, NULL, "intrinsic");
	intrinsic = (CvMat *) cvRead(fs, param);
	param = cvGetFileNodeByName(fs, NULL, "distortion");
	distortion = (CvMat *) cvRead (fs, param);
	cvReleaseFileStorage(&fs);

	ostringstream path;
	for(int i = 0; i < 6; ++ i){
		path.str("");
		path << PATH << i << "." << SUFFIX;
		cout << "[" << path.str().c_str() << "]" << endl;
		opencv::cvutil::Image<IPL_DEPTH_8U> src_img(path.str().c_str(), CV_LOAD_IMAGE_COLOR);
		opencv::cvutil::Image<IPL_DEPTH_8U> src_img_ud(src_img.getWidth(), src_img.getHeight(), src_img.getNChannels());

		cvUndistort2(src_img, src_img_ud, intrinsic, distortion);

		win.display(src_img_ud);

		cvWaitKey();
	}

#endif

#if 0
	static const int W = 640, H = 480;
	opencv::cvutil::Window win("Capture");
	win.open();

	opencv::cvutil::Camera cam;
	cam.initialize(W, H, 0);
#endif

#if 0
	opencv::cvutil::Image<IPL_DEPTH_8U> frm(W, H, 3);
	
	while(win.isAlive()){
		frm.copy(cam.query());
		win.display(frm);
		win.wait(10);
	}
	
#endif

#if 0
	opencv::cvutil::Image<IPL_DEPTH_8U> frm(W, H, 3), hsv(W, H, 3), hue(W, H, 1);
	
#if 0
	frm.clear();
	for(int v = 0; v < frm.getHeight(); v ++)
		for(int u = 0; u < frm.getWidth(); u ++)
			frm(u, v, 0, v,	frm(u, v, 1, v,	frm(u, v, 2, v;
	
	frm.show("test");	cvWaitKey();	getchar();
#endif

	opencv::cvutil::Image<IPL_DEPTH_8U> frm_buf[1000];
	
	for(int i = 0; i < 1000; i ++)
		frm_buf[i].create(W, H, 3);

	int frm_i_to_be_used;
	win.wait(10000);
	for(frm_i_to_be_used = 0; win.isAlive() && frm_i_to_be_used < 1000; frm_i_to_be_used ++){
		frm_buf[frm_i_to_be_used].copy(cam.query());
		win.display(frm_buf[frm_i_to_be_used]);
		win.wait(50);
	}

	char name[128];
	for(frm_i_to_be_used --; frm_i_to_be_used >= 0; frm_i_to_be_used --){
		sprintf_s(name, 128, "Frames/%04d.png", frm_i_to_be_used);
		frm_buf[frm_i_to_be_used].save(name);
	}

#if 0
	while(win.isAlive()){
		frm.copy(cam.query());
		frm.convert(hsv, CV_BGR2HSV);
		hue.copyChannel(hsv, 0, 0);

		win.display(hue);
		win.wait(10);
	}
#endif

#endif

#if 0
	opencv::cvutil::Image<IPL_DEPTH_8U> *img, diff(W, H, 3);
	img = new opencv::cvutil::Image<IPL_DEPTH_8U> [2];
	img[0].create(W, H, 3);
	img[1].create(W, H, 3);

	int i = 0;
	img[0].copy(cam.query());
	img[1].copy(cam.query());
	while(win.isAlive()){
		i = (i+1)%2;

		img[i].copy(cam.query());

		cvSub(img[i], img[(i+1)%2], diff);

		win.display(diff);

		win.wait(20);
	}

	delete [] img;
#endif

	return 0;
}