#define CVUTIL_LINK_LIBS_220
#include "../cvutil/cvutil.h"
#include <iostream>

const int START = 0;
const int FINAL = 1574;
const char *DIR_PATH = "C:/Users/aisl/Documents/sugiyama/vbi-data/results-skip";
bool vertical = true;

void bindImage(
	char *f_path, char *m_path, char *fm_path, 
	opencv::cvutil::Image<IPL_DEPTH_8U> &fm_ipl,
	int frm_i)
{
	sprintf_s( f_path, 1024, "%s/f%04d-slam.png", DIR_PATH, frm_i );
	sprintf_s( m_path, 1024, "%s/m%04d-slam.png", DIR_PATH, frm_i );
	sprintf_s( fm_path, 1024, "%s/%04d.bmp", DIR_PATH, frm_i );

	opencv::cvutil::Image<IPL_DEPTH_8U> f_ipl(f_path, CV_LOAD_IMAGE_COLOR);
	opencv::cvutil::Image<IPL_DEPTH_8U> m_ipl(m_path, CV_LOAD_IMAGE_COLOR);

	fm_ipl.copy(f_ipl, 0, 0, 0, 0, f_ipl.getWidth(), f_ipl.getHeight());
	fm_ipl.copy(m_ipl, 0, 0, f_ipl.getWidth(), 0, m_ipl.getWidth(), m_ipl.getHeight());
	fm_ipl.save(fm_path);
}

void bindImageV(
	char *f_path, char *m_path, char *fm_path, 
	opencv::cvutil::Image<IPL_DEPTH_8U> &fm_ipl,
	int frm_i)
{
	sprintf_s( f_path, 1024, "%s/f%04d-slam.png", DIR_PATH, frm_i );
	sprintf_s( m_path, 1024, "%s/m%04d-slam.png", DIR_PATH, frm_i );
	sprintf_s( fm_path, 1024, "%s/%04d.bmp", DIR_PATH, frm_i );

	opencv::cvutil::Image<IPL_DEPTH_8U> f_ipl(f_path, CV_LOAD_IMAGE_COLOR);
	opencv::cvutil::Image<IPL_DEPTH_8U> m_ipl(m_path, CV_LOAD_IMAGE_COLOR);

	fm_ipl.copy(f_ipl, 0, 0, 0, 0, f_ipl.getWidth(), f_ipl.getHeight());
	fm_ipl.copy(m_ipl, 0, 0, 0, f_ipl.getHeight(), m_ipl.getWidth(), m_ipl.getHeight());
	fm_ipl.save(fm_path);
}


int main()
{
	char f_path[1024], m_path[1024], fm_path[1024];

	opencv::cvutil::Image < IPL_DEPTH_8U > fm_ipl;

	// ߂̈
	// fm_ipl̃TCYݒ
	{
		sprintf_s( f_path, 1024, "%s/f%04d-slam.png", DIR_PATH, START );
		sprintf_s( m_path, 1024, "%s/m%04d-slam.png", DIR_PATH, START );

		opencv::cvutil::Image < IPL_DEPTH_8U > f_ipl ( f_path, CV_LOAD_IMAGE_COLOR );
		opencv::cvutil::Image < IPL_DEPTH_8U > m_ipl ( m_path, CV_LOAD_IMAGE_COLOR );

		if(vertical){
			fm_ipl.create (
				f_ipl.getWidth() > m_ipl.getWidth() ? f_ipl.getWidth() : m_ipl.getWidth(),
				f_ipl.getHeight() + m_ipl.getHeight(), 
				3 );
		}
		else{
			fm_ipl.create (
				f_ipl.getWidth() + m_ipl.getWidth(), 
				f_ipl.getHeight() > m_ipl.getHeight() ? f_ipl.getHeight() : m_ipl.getHeight(),
				3 );
		}
	}

	if(vertical){
		for ( int frm_i = START; frm_i <= FINAL; ++ frm_i ) {
			bindImageV(f_path, m_path, fm_path, fm_ipl, frm_i);
			printf("%s\n", fm_path);
		}
	}
	else{
		for ( int frm_i = START; frm_i <= FINAL; ++ frm_i ) {
			bindImage(f_path, m_path, fm_path, fm_ipl, frm_i);
			printf("%s\n", fm_path);
		}
	}

	return 0;
}