/*************************************************************************/
/*                                                                       */
/*   show-superimpose.c: ʂd\                                  */
/*                                                                       */
/*************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "opencv/cvutil/cvutil.h"
//#include <opencv/cv.h>
//#include <opencv/highgui.h>

#include "pixel.h"
#include "icp3d.h"
#include "mesaRangeData.h"
#include "myutil.h"
#include "ip.h"

#define MAX_DISTANCE	3.0


/* Swissranger, averaged values for foreground[1-6].dat  */
#define FX (-244.87)
#define FY (-245.729)
#define U0 (87.164)
#define V0 (70.70785)


#define SAVE_IMAGE

int	imgid=0;

CvPoint init_vertices[8], vertices[8];
//~`p
CvPoint init_upper_vertices[8], init_lower_vertices[8], upper_vertices[8], lower_vertices[8];
CvSize r_size;
IplImage *imgZorg, *imgZuse, *imgZmask;

extern double groval_xval[25534];
extern double groval_yval[25534];
extern double groval_zval[25534];

void scene_to_image(double X, double Y, double Z, int *x, int *y)
{
  *x = (int)(FX * X / Z + U0);
  *y = (int)(FY * Y / Z + V0);
//  fprintf(stderr, "S2I:(%f,%f,%f)==>(%d,%d)\n", X, Y, Z, *x, *y);
}

void save_image_with_id(IplImage *img)
{
  char filename[MAXCHARS];

  sprintf_s(filename, MAXCHARS, "img%04d.bmp", imgid);
  imgid++;

  cvSaveImage(filename, img);
}

/*
	SwissRangerRTC擾f[^ŋ摜𐶐
*/
void DrawDistanceImg(){

	int ind, w, h;
	unsigned char uval;
	double maxz = 0.0;

	for(h = 0; h < data_height; h++ )
	{
		for(w = 0; w < data_width; w++)
			maxz = max(maxz, groval_zval[(data_width * h) + w]);
	}

	for(h = 0; h < data_height; h++)
	{
		for(w = 0; w < data_width; w++)
		{
			uval = (unsigned char)(groval_zval[(data_width * h) + w] * 255.0 / (maxz + 0.1));

			imgZorg->imageData[imgZorg->widthStep * h + w] = uval;
			imgZuse->imageData[imgZuse->widthStep * h + w] = uval;
		}
	}
		
}

//---------------------------------------------------------------------------------------//
/*
  OiCwif[^摜𐶐D
  foreval, backval 璼ډ摜΂悢i̍ől͋߂KvjD
*/
void initialize_superimpose()
{
	int h, w, ind;
	double z, maxz;
	unsigned char uz;


	fprintf(stderr, "initialize superimpose.\n");

	if ((forexval == NULL)/* || (backxval == NULL)*/){
		fprintf(stderr, "foreground and background data in XYZ are necessary.\n");
		exit(-1);
	}

	//for debug
	
	cvNamedWindow("superimpose image", 0);
	cvMoveWindow("superimpose image", 400, 700);

  /*
    摜̃TCY\
  */
	fprintf(stderr, "width = %d, height = %d\n", data_width, data_height);

 /*
    őZl̎擾
  */

	//
	r_size = cvSize(data_width, data_height);

	//ڌʒl摜摜

	imgZorg = cvCreateImage(r_size, IPL_DEPTH_8U, 1);
	imgZuse = cvCreateImage(r_size, IPL_DEPTH_8U, 1);
	imgZmask = cvCreateImage(r_size, IPL_DEPTH_8U, 1);

	/*
		f[^8bitɕϊCo͉摜ɃZbg
	*/

	//SwissRanger̋f[^ŋ摜
	DrawDistanceImg();

}

void set_init_vertices(point points[8])
{
  int i, n, h, w;
  
  for (i = 0; i < 8; i++){
    scene_to_image(points[i].x, points[i].y, points[i].z,
		   &(init_vertices[i].x), &(init_vertices[i].y));
  }

  cvCopy(imgZorg, imgZuse);

  /*  show init vertices  */
  cvLine(imgZuse, init_vertices[0], init_vertices[1], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[1], init_vertices[2], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[2], init_vertices[3], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[3], init_vertices[0], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[4], init_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[5], init_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[6], init_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[7], init_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[0], init_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[1], init_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[2], init_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[3], init_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
  
  /*
    n {Ɋgin͐j
  */
  n = 4;
  CvSize r_size2 = cvSize(data_width * n, data_height * n);
  IplImage *imgZ2 = cvCreateImage(r_size2, IPL_DEPTH_8U, 1);

  for (h = 0; h < data_height*n; h++)
    for (w = 0; w < data_width*n; w++){
      SetIgray(imgZ2, w, h, GetIgray(imgZuse, (int)(w/n), (int)(h/n)));
    }
  
  /*
    摜ۑ
  */
#ifdef SAVE_IMAGE
  save_image_with_id(imgZ2);
#endif
  
/* 
 *   cvShowImage("image", imgZ);
 */
//for debug
    cvShowImage("superimpose image", imgZ2);

/* 
 *   cvWaitKey(0);
 */
  //for debug
  cvWaitKey(0);
  /*
    J
  */

  cvReleaseImage( &imgZ2 );
 
  return;
}
//~
void set_init_cylinder_vertices(point upper[8], point lower[8])
{
  int i, n, h, w;
  
  for (i = 0; i < 8; i++){
    scene_to_image(upper[i].x, upper[i].y, upper[i].z,
		   &(init_upper_vertices[i].x), &(init_upper_vertices[i].y));
    scene_to_image(lower[i].x, lower[i].y, lower[i].z,
	   &(init_lower_vertices[i].x), &(init_lower_vertices[i].y));
  }
  
  cvCopy(imgZorg, imgZuse);

  /*  show init vertices  */
  cvLine(imgZuse, init_upper_vertices[0], init_upper_vertices[1], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_upper_vertices[1], init_upper_vertices[2], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_upper_vertices[2], init_upper_vertices[3], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_upper_vertices[3], init_upper_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_upper_vertices[4], init_upper_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_upper_vertices[5], init_upper_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_upper_vertices[6], init_upper_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_upper_vertices[7], init_upper_vertices[0], CV_RGB(200, 200, 200), 1, 8, 0);

  cvLine(imgZuse, init_lower_vertices[0], init_lower_vertices[1], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_lower_vertices[1], init_lower_vertices[2], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_lower_vertices[2], init_lower_vertices[3], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_lower_vertices[3], init_lower_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_lower_vertices[4], init_lower_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_lower_vertices[5], init_lower_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_lower_vertices[6], init_lower_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_lower_vertices[7], init_lower_vertices[0], CV_RGB(200, 200, 200), 1, 8, 0);

  cvLine(imgZuse, init_upper_vertices[0], init_lower_vertices[0], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_upper_vertices[4], init_lower_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  
  /*
    n {Ɋgin͐j
  */
  n = 4;
  CvSize r_size2 = cvSize(data_width * n, data_height * n);
  IplImage *imgZ2 = cvCreateImage(r_size2, IPL_DEPTH_8U, 1);

  for (h = 0; h < data_height*n; h++)
    for (w = 0; w < data_width*n; w++){
      SetIgray(imgZ2, w, h, GetIgray(imgZuse, (int)(w/n), (int)(h/n)));
    }
  
  /*
    摜ۑ
  */
#ifdef SAVE_IMAGE
  save_image_with_id(imgZ2);
#endif
  
/* 
 *   cvShowImage("image", imgZ);
 */
  cvShowImage("superimpose image", imgZ2);

/* 
 *   cvWaitKey(0);
 */
  cvWaitKey(10);
  /*
    J
  */
  cvReleaseImage( &imgZ2 );

  return;
}

/*
 * Ή_̑góifobOpj
 */
void show_correspondence(int to_show, point p1, point p2)
{
  CvPoint ip1, ip2;
  int	h, w;

/* 
 *   fprintf(stderr, "(%d)Enter ShowCorresponence:(%f, %f, %f)--(%f, %f, %f)\n",
 *	     to_show, p1.x, p1.y, p1.z, p2.x, p2.y, p2.z);
 *   fprintf(stderr, "	 diff vector = (%f, %f, %f)\n",
 *	     p1.x - p2.x, p1.y - p2.y, p1.z - p2.z);
 */
  
  if (to_show){
    int n = 4;
    CvSize r_size2 = cvSize(data_width * n, data_height * n);
    IplImage *imgZ2 = cvCreateImage(r_size2, IPL_DEPTH_8U, 1);

    for (h = 0; h < data_height*n; h++)
      for (w = 0; w < data_width*n; w++){
		  SetIgray(imgZ2, w, h, GetIgray(imgZuse, (int)(w/n), (int)(h/n)));
      }
    
#ifdef SAVE_IMAGE
  save_image_with_id(imgZ2);
#endif
  
  //for debug
  cvShowImage("superimpose image", imgZ2);
  
  cvWaitKey(50);
  /*
    J
  */
  cvReleaseImage( &imgZ2 );
  }
  else{				/* add line */
    scene_to_image(p1.x, p1.y, p1.z, &(ip1.x), &(ip1.y));
    scene_to_image(p2.x, p2.y, p2.z, &(ip2.x), &(ip2.y));
    cvLine(imgZuse, ip1, ip2, CV_RGB(230, 230, 200), 1, 8, 0);
  }

  return;
}

// #define ALWAYS_SHOW_INIT_VERTICES
/*
 * ʒǔʂ\íj
 */
void show_vertices(point points[8])
{
  int i, n = 4, w, h;
  
  for (i = 0; i < 8; i++){
    scene_to_image(points[i].x, points[i].y, points[i].z,
		   &(vertices[i].x), &(vertices[i].y));
  }

  cvCopy(imgZorg, imgZuse);

#ifdef ALWAYS_SHOW_INIT_VERTICES
  /*  show init vertices  */
  cvLine(imgZuse, init_vertices[0], init_vertices[1], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[1], init_vertices[2], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[2], init_vertices[3], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[3], init_vertices[0], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[4], init_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[5], init_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[6], init_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[7], init_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[0], init_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[1], init_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[2], init_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[3], init_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
#endif

  /*  show current vertices  */
  cvLine(imgZuse, vertices[0], vertices[1], CV_RGB(255, 255, 255), 1, 8, 0);
  cvLine(imgZuse, vertices[1], vertices[2], CV_RGB(255, 255, 255), 1, 8, 0);
  cvLine(imgZuse, vertices[2], vertices[3], CV_RGB(255, 255, 255), 1, 8, 0);
  cvLine(imgZuse, vertices[3], vertices[0], CV_RGB(255, 255, 255), 1, 8, 0);
  cvLine(imgZuse, vertices[4], vertices[5], CV_RGB(255, 255, 255), 1, 8, 0);
  cvLine(imgZuse, vertices[5], vertices[6], CV_RGB(255, 255, 255), 1, 8, 0);
  cvLine(imgZuse, vertices[6], vertices[7], CV_RGB(255, 255, 255), 1, 8, 0);
  cvLine(imgZuse, vertices[7], vertices[4], CV_RGB(255, 255, 255), 1, 8, 0);
  cvLine(imgZuse, vertices[0], vertices[5], CV_RGB(255, 255, 255), 1, 8, 0);
  cvLine(imgZuse, vertices[1], vertices[4], CV_RGB(255, 255, 255), 1, 8, 0);
  cvLine(imgZuse, vertices[2], vertices[7], CV_RGB(255, 255, 255), 1, 8, 0);
  cvLine(imgZuse, vertices[3], vertices[6], CV_RGB(255, 255, 255), 1, 8, 0);

  /*
    n {Ɋgin͐j
  */
  n = 4;
  CvSize r_size2 = cvSize(data_width * n, data_height * n);
  IplImage *imgZ2 = cvCreateImage(r_size2, IPL_DEPTH_8U, 1);

  for (h = 0; h < data_height*n; h++)
    for (w = 0; w < data_width*n; w++){
      SetIgray(imgZ2, w, h, GetIgray(imgZuse, (int)(w/n), (int)(h/n)));
    }
  
  /*
    摜ۑ
  */
#ifdef SAVE_IMAGE
  save_image_with_id(imgZ2);
#endif

  //for debug
  cvShowImage("superimpose image", imgZ2);

 
    cvWaitKey(50);
 
  //for debug
//  cvWaitKey(10);
  /*
    J
  */
  cvReleaseImage( &imgZ2 );

  return;
}
/*
 * ʒǔʂ\i~j
 */
void show_cylinder_vertices(point upper[8], point lower[8])
{
	printf("show_cylinder_vertices\n");

  int i, n, h, w;
  
  for (i = 0; i < 8; i++){
    scene_to_image(upper[i].x, upper[i].y, upper[i].z,
		   &(upper_vertices[i].x), &(upper_vertices[i].y));
    scene_to_image(lower[i].x, lower[i].y, lower[i].z,
	   &(lower_vertices[i].x), &(lower_vertices[i].y));
  }

  cvCopy(imgZorg, imgZuse);

  /*  show init vertices  */
  cvLine(imgZuse, upper_vertices[0], upper_vertices[1], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, upper_vertices[1], upper_vertices[2], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, upper_vertices[2], upper_vertices[3], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, upper_vertices[3], upper_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, upper_vertices[4], upper_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, upper_vertices[5], upper_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, upper_vertices[6], upper_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, upper_vertices[7], upper_vertices[0], CV_RGB(200, 200, 200), 1, 8, 0);

  cvLine(imgZuse, lower_vertices[0], lower_vertices[1], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, lower_vertices[1], lower_vertices[2], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, lower_vertices[2], lower_vertices[3], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, lower_vertices[3], lower_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, lower_vertices[4], lower_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, lower_vertices[5], lower_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, lower_vertices[6], lower_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, lower_vertices[7], lower_vertices[0], CV_RGB(200, 200, 200), 1, 8, 0);

  cvLine(imgZuse, upper_vertices[0], lower_vertices[0], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, upper_vertices[2], lower_vertices[2], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, upper_vertices[4], lower_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, upper_vertices[6], lower_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
  
  /*
    n {Ɋgin͐j
  */
  n = 4;
  CvSize r_size2 = cvSize(data_width * n, data_height * n);
  IplImage *imgZ2 = cvCreateImage(r_size2, IPL_DEPTH_8U, 1);

  for (h = 0; h < data_height*n; h++)
    for (w = 0; w < data_width*n; w++){
      SetIgray(imgZ2, w, h, GetIgray(imgZuse, (int)(w/n), (int)(h/n)));
    }
  
  /*
    摜ۑ
  */
#ifdef SAVE_IMAGE
  save_image_with_id(imgZ2);
#endif
  
/* 
 *   cvShowImage("image", imgZ);
 */
  cvShowImage("superimpose image", imgZ2);

/* 
 *   cvWaitKey(0);
 */
  cvWaitKey(10);
  /*
    J
  */
  cvReleaseImage( &imgZ2 );

  return;
}
/*
 *߂ʂ̑1`3oĂ݂ifobOpj
 */
void show_axis(point averagep, point *axisp)
{
  int i, n = 4, w, h;
  
  CvPoint average;
  CvPoint axis[3];

  scene_to_image(averagep.x, averagep.y, averagep.z,
		   &(average.x), &(average.y));

  for (i = 0; i < 3; i++){
    scene_to_image((axisp[i].x*2), (axisp[i].y*2), (axisp[i].z*2),
		&(axis[i].x), &(axis[i].y));
  }

  IplImage *imgAxisorg;
  IplImage *imgAxisuse;

  imgAxisorg = cvLoadImage("foregroundamplitude.png", CV_LOAD_IMAGE_COLOR);
  printf("loadimage\n");

  imgAxisuse = cvCreateImage(cvSize(data_width, data_height), imgAxisorg->depth, imgAxisorg->nChannels);

  cvCopy(imgAxisorg, imgAxisuse);
  printf("copy\n");

//  cvCopy(imgZorg, imgZuse, imgZmask);

#ifdef ALWAYS_SHOW_INIT_VERTICES
  /*  show init vertices  */
  cvLine(imgZuse, init_vertices[0], init_vertices[1], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[1], init_vertices[2], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[2], init_vertices[3], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[3], init_vertices[0], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[4], init_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[5], init_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[6], init_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[7], init_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[0], init_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[1], init_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[2], init_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[3], init_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
#endif

  /*  show current vertices  */
  cvLine(imgAxisuse, average, axis[0], CV_RGB(255, 0, 0), 1, 8, 0);
  cvLine(imgAxisuse, average, axis[1], CV_RGB(0, 255, 0), 1, 8, 0);
  cvLine(imgAxisuse, average, axis[2], CV_RGB(0, 0, 255), 1, 8, 0);

  printf("line\n");
  /*
    n {Ɋgin͐j
  */
/*  n = 4;
  CvSize r_size2 = cvSize(data_width * n, data_height * n);
  IplImage *imgZ2 = cvCreateImage(r_size2, IPL_DEPTH_8U, 1);

  for (h = 0; h < data_height*n; h++)
    for (w = 0; w < data_width*n; w++){
      SetIgray(imgZ2, w, h, GetIgray(imgZuse, (int)(w/n), (int)(h/n)));
    }*/
  
  /*
    摜ۑ
  */
#ifdef SAVE_IMAGE
  //save_image_with_id(imgZ2);
	cvSaveImage("axis image.png", imgAxisuse);
	printf("save\n");
#endif

	cvNamedWindow("axis image");

  //for debug
  cvShowImage("axis image", imgAxisuse); 
    cvWaitKey(100);

  printf("show\n");

 
  //for debug
//  cvWaitKey(10);
  /*
    J
  */
  cvReleaseImage( &imgAxisuse );
  cvReleaseImage( &imgAxisorg);

	cvDestroyWindow("axis image");

  printf("release\n");

  return;
}

/*
 *̏ʒuóifobOpj
 */
void show_initpoints(point *initpointsp)
{
  int i, n = 4, w, h;
  
  CvPoint initpoints[8];

  for (i = 0; i < 8; i++){
    scene_to_image((initpointsp[i].x*2), (initpointsp[i].y*2), (initpointsp[i].z*2),
		&(initpoints[i].x), &(initpoints[i].y));
  }

  IplImage *imgPointsorg;
  IplImage *imgPointsuse;

  imgPointsorg = cvLoadImage("foregroundamplitude.png", CV_LOAD_IMAGE_COLOR);

  imgPointsuse = cvCreateImage(cvSize(data_width, data_height), imgPointsorg->depth, imgPointsorg->nChannels);

  cvCopy(imgPointsorg, imgPointsuse);

//  cvCopy(imgZorg, imgZuse, imgZmask);

#ifdef ALWAYS_SHOW_INIT_VERTICES
  /*  show init vertices  */
  cvLine(imgZuse, init_vertices[0], init_vertices[1], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[1], init_vertices[2], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[2], init_vertices[3], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[3], init_vertices[0], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[4], init_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[5], init_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[6], init_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[7], init_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[0], init_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[1], init_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[2], init_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[3], init_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
#endif

	cvCircle(imgPointsuse, initpoints[0], 3, CV_RGB(255, 0, 0), 1);
	cvCircle(imgPointsuse, initpoints[1], 3, CV_RGB(0, 255, 0), 1);
	cvCircle(imgPointsuse, initpoints[2], 3, CV_RGB(0, 0, 255), 1);
	cvCircle(imgPointsuse, initpoints[3], 3, CV_RGB(255, 255, 0), 1);
	cvCircle(imgPointsuse, initpoints[4], 3, CV_RGB(0, 255, 255), 1);
	cvCircle(imgPointsuse, initpoints[5], 3, CV_RGB(255, 0, 255), 1);
	cvCircle(imgPointsuse, initpoints[6], 3, CV_RGB(255, 255, 255), 1);
	cvCircle(imgPointsuse, initpoints[7], 3, CV_RGB(142, 0, 204), 1);
  
  /*
    摜ۑ
  */
#ifdef SAVE_IMAGE
  //save_image_with_id(imgZ2);
	cvSaveImage("initpoints image.png", imgPointsuse);
#endif

	cvNamedWindow("initpoints image");

  //for debug
  cvShowImage("initpoints image", imgPointsuse);

 
    cvWaitKey(100);
 
  //for debug
//  cvWaitKey(10);
  /*
    J
  */
  cvReleaseImage( &imgPointsuse );
  cvReleaseImage( &imgPointsorg);

  cvDestroyWindow("initpoints image");

  return;
}
/*
 *~̏ʒuóifobOpj
 */
void show_initpoints_cylinder(point *initpointsp)
{
  int i, n = 4, w, h;
  
  CvPoint initpoints[2];

  for (i = 0; i < 2; i++){
    scene_to_image((initpointsp[i].x*2), (initpointsp[i].y*2), (initpointsp[i].z*2),
		&(initpoints[i].x), &(initpoints[i].y));
  }

  IplImage *imgPointsorg;
  IplImage *imgPointsuse;

  imgPointsorg = cvLoadImage("foregroundamplitude.png", CV_LOAD_IMAGE_COLOR);
  imgPointsuse = cvCreateImage(cvSize(data_width, data_height), imgPointsorg->depth, imgPointsorg->nChannels);

  cvCopy(imgPointsorg, imgPointsuse);


#ifdef ALWAYS_SHOW_INIT_VERTICES
  /*  show init vertices  */
  cvLine(imgZuse, init_vertices[0], init_vertices[1], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[1], init_vertices[2], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[2], init_vertices[3], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[3], init_vertices[0], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[4], init_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[5], init_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[6], init_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[7], init_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[0], init_vertices[5], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[1], init_vertices[4], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[2], init_vertices[7], CV_RGB(200, 200, 200), 1, 8, 0);
  cvLine(imgZuse, init_vertices[3], init_vertices[6], CV_RGB(200, 200, 200), 1, 8, 0);
#endif

	cvCircle(imgPointsuse, initpoints[0], 3, CV_RGB(255, 0, 0), 1);
	cvCircle(imgPointsuse, initpoints[1], 3, CV_RGB(0, 255, 0), 1);
  
  /*
    摜ۑ
  */
#ifdef SAVE_IMAGE
  //save_image_with_id(imgZ2);
	cvSaveImage("initpoints image.png", imgPointsuse);
#endif

	cvNamedWindow("initpoints image");

  //for debug
  cvShowImage("initpoints image", imgPointsuse);

 
    cvWaitKey(100);
 
  //for debug
//  cvWaitKey(10);
  /*
    J
  */
  cvReleaseImage( &imgPointsuse );
  cvReleaseImage( &imgPointsorg);

  cvDestroyWindow("initpoints image");

  return;
}